//+------------------------------------------------------------------+
//|                                                   ay-MP-Text.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, ahmad.yani@hotmail.com"
#property link      "http://eyesfx.web44.net"

#property indicator_chart_window
/******************************************************************\\\
 * MP Library 
 * dont change anything in this mp library block, unless YKWYD.....
 ******************************************************************///say something here...
#include <ay-mplib.const.mqh>                                       //
                                                                    //
#import "ay-mplib100.ex4"                                           //
void MpGet                                                          //
   (                                                                //   
        double    dparam[4]                                         //
      , int       iparam[2]                                         //
      , double    arates[][6]                                       //
      , double&   mpdata[][MPSIZE]                                  //result: data
      , int&      mplinesidx[MPLNSIZE]                              //result: lines index
      , double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
      , int&      mpletter[][MPLTSIZE]                              //result: letter  
   );                                                               //
#import                                                             //
/******************************************************************\\\
 * End MP Library 
 ******************************************************************///
 
/******************************************************************\\\
 * Indicator Constant
 ******************************************************************/// 
#define INDNAME                     "AY.TPOChart"
#define INDVER                      "1.02"
 
#define PERIOD_Y1                   518400
#define PERIOD_Q1                   129600  

#define FONTNAME                    "Consolas"
#define FONTNAME2                   "Consolas Bold"
#define FONTSIZE                    8
#define FONTSIZE2                   8

#define CTRLMODELETTER              0
#define CTRLPROFILEINFO             1
#define CTRLOHLCBAR                 2
#define CTRLIB                      3
#define CTRLDIB                     4
#define CTRLTVPOINFO                5

#define STARTX                      10
#define STARTY                      15
#define CTRLSTARTY                  90
#define XPOSCTRLMODELETTER          STARTX
#define XPOSCTRLPROFILEINFO         25
#define XPOSCTRLOHLCBAR             40
#define XPOSCTRLIB                  55
#define XPOSCTRLDIB                 70
#define XPOSCTRLTVPOINFO            85

#define CTRLONCOLOR                 RoyalBlue
#define CTRLOFFCOLOR                DeepPink

#define GVMODELETTER                0 
#define GVSHOWPROFILEINFO           1 
#define GVSHOWCURRENTTVPO           2 
#define GVSHOWOHLCBAR               3 
#define GVSHOWIB                    4 
#define GVSHOWDIB                   5 
/******************************************************************\\\
 * End Indicator Constant
 ******************************************************************/// 

/******************************************************************\\\
 * Extern Vars
 ******************************************************************///  
extern int        LookBack                = 10;
extern string     ProfileTimeframeInfo    = "use D1, W1, MN1, Q1, Y1";
extern string     ProfileTimeframe        = "D1";
extern int        DayStartHour            = 0;
extern double     VAPercent               = 70.0;

extern string     spr0                    = "On/Off.............";
extern bool       ModeLetter              = True;
extern bool       ShowProfileInfo         = true;
extern bool       ShowCurrentTVPO         = false;
extern bool       ShowOHLCBar             = true;
extern bool       ShowIB                  = true;
extern bool       ShowDIB                 = false;

extern string     spr1                    = "Colors.............";
extern color      LetterColor             = RosyBrown;
extern color      HistogramColor          = C'25,25,150';
extern color      VAColor                 = C'0,25,50';
extern color      POCColor                = LightSteelBlue;
extern color      IBColor                 = Gray;
extern color      DIBColor                = LightBlue;
extern color      BarBullColor            = C'0,200,0';
extern color      BarBearColor            = C'200,0,0';
extern color      BarNetralColor          = DimGray;
extern color      CurrentLetterColor      = Gray;

extern string     spr2                    = "Profile Data.......";
extern string     DailyProfileDataTf      = "M30";
extern string     WeeklyProfileDataTf     = "H1";
extern string     MonthlyProfileDataTf    = "H4";
extern string     QuarterlyProfileDataTf  = "D1";
extern string     YearlyProfileDataTf     = "D1";

extern string     spr3                    = "Initial Balance.......";
extern string     DailyIBTf               = "H1";
extern string     WeeklyIBTf              = "D1";
extern string     MonthlyIBTf             = "D1";
extern string     QuarterlyIBTf           = "MN1";
extern string     YearlyIBTf              = "MN1";
extern int        DailyIBNumBars          = 1;
extern int        WeeklyIBNumBars         = 2;
extern int        MonthlyIBNumBars        = 6;
extern int        QuarterlyIBNumBars      = 1;
extern int        YearlyIBNumBars         = 3;

extern string     spr4                    = "Row Height";
extern int        DailyRowHeight          = 5;
extern int        WeeklyRowHeight         = 10;
extern int        MonthlyRowHeight        = 15;
extern int        QuarterlyRowHeight      = 25;
extern int        YearlyRowHeight         = 50;

extern string     spr5                    = "........";
extern int        InfoCorner              = 0;
extern int        UpdateInterval          = 1;
extern int        IndicatorId             = 0;

extern string     spr6                    = "Session hour & color";
extern int        TokyoOpen               = 0;
extern int        LondonOpen              = 7;
extern int        NewyorkOpen             = 12;
extern color      AsColor                 = RosyBrown;
extern color      EuColor                 = Aqua;
extern color      UsColor                 = Khaki;

extern string     spr7                    = "Day/Week/Month Letter Color";
extern color      LtColor1                 = Goldenrod;
extern color      LtColor2                 = Aqua;
extern color      LtColor3                 = ForestGreen;
extern color      LtColor4                 = Magenta; 
extern color      LtColor5                 = White;
extern color      LtColor6                 = Yellow;
extern color      LtColor7                 = RosyBrown;
extern color      LtColor8                 = Teal;
extern color      LtColor9                 = Chocolate;
extern color      LtColor10                = Lime;
extern color      LtColor11                = Red;
extern color      LtColor12                = Tomato;
/******************************************************************\\\
 * End Extern Vars
 ******************************************************************/// 
 
//-->Global Vars
int      giDigits
       , giDataTf
       , giProfileTf
       , giIBTf
       , giIBNumBars
       , giRowHeight
       , giStep;
      // , giTOLtId
      // , giLOLtId
      // , giNOLtId;
      // , giMpHandle;      

double   gdPoint
       , gdRowtHeight
       , gdOneTick
       , gdaRates[][6];
       
string  gsaLetter[] = 
   {
    "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","P","W","X","Y","Z"
   ,"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","p","w","x","y","z"
   };

bool     gbOnOffControl[6];
int      giControlPosX[6];     
string   gsPref      = "ay.mptpo.";
string   gsaGVName[] = {
                           "ModeLetter"        //GVMODELETTER
                         , "ShowProfileInfo"   //GVSHOWPROFILEINFO
                         , "ShowCurrentTVPO"   //GVSHOWCURRENTTVPO
                         , "ShowOHLCBar"       //GVSHOWOHLCBAR
                         , "ShowIB"            //GVSHOWIB
                         , "ShowDIB"           //GVSHOWDIB
                       }; 

color             gcLtColor[12];                
//<--Global Vars

#include <ay-object.func.mqh>       
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorDigits(Digits);
   
   //giMpHandle = MpInit();
   
   if (Point == 0.001 || Point == 0.00001) 
   { gdPoint = Point*10; giDigits = Digits - 1; }
   else 
   { gdPoint = Point; giDigits = Digits; }     
   
   gdOneTick = 1/MathPow(10, giDigits);
   
   gsPref = gsPref + ProfileTimeframe + ".";
      
   setConfig();

   drawSettingInfo(); 
   return(0);
}

/**
 * setConfig
 */
void setConfig()
{

   giProfileTf = getTfByName(ProfileTimeframe);
   
   switch (giProfileTf)
   {
      case PERIOD_Y1:
         giDataTf    = getTfByName(YearlyProfileDataTf);
         giIBTf      = getTfByName(YearlyIBTf); 
         giIBNumBars = YearlyIBNumBars;    
         giRowHeight = YearlyRowHeight;             
         break;
      case PERIOD_Q1:
         giDataTf    = getTfByName(QuarterlyProfileDataTf);
         giIBTf      = getTfByName(QuarterlyIBTf); 
         giIBNumBars = QuarterlyIBNumBars;        
         giRowHeight = QuarterlyRowHeight;             
         break;
      case PERIOD_MN1:
         giDataTf    = getTfByName(MonthlyProfileDataTf);
         giIBTf      = getTfByName(MonthlyIBTf); 
         giIBNumBars = MonthlyIBNumBars;
         giRowHeight = MonthlyRowHeight;                     
         break;
      case PERIOD_W1:
         giDataTf    = getTfByName(WeeklyProfileDataTf);
         giIBTf      = getTfByName(WeeklyIBTf); 
         giIBNumBars = WeeklyIBNumBars; 
         giRowHeight = WeeklyRowHeight;                    
         break;
      default:
         giDataTf    = getTfByName(DailyProfileDataTf);
         giIBTf      = getTfByName(DailyIBTf); 
         giIBNumBars = DailyIBNumBars; 
         giRowHeight = DailyRowHeight;                                      
         break;
                           
   }
              
   
   giStep = MathMax(giRowHeight, 1);

   ArrayCopyRates(gdaRates, NULL, giDataTf);
   
   
   //--> day/week/month letter color
   gcLtColor[0]  = LtColor1;
   gcLtColor[1]  = LtColor2;
   gcLtColor[2]  = LtColor3;
   gcLtColor[3]  = LtColor4;
   gcLtColor[4]  = LtColor5;
   gcLtColor[5]  = LtColor6;
   gcLtColor[6]  = LtColor7;
   gcLtColor[7]  = LtColor8;
   gcLtColor[8]  = LtColor9;
   gcLtColor[9]  = LtColor10;
   gcLtColor[10] = LtColor11;
   gcLtColor[11] = LtColor12;
   //<-- day/week/month letter color
   
   
   //-->On/Off Control
   storeCtrlSetting();
   
   giControlPosX[CTRLMODELETTER ] = XPOSCTRLMODELETTER;
   giControlPosX[CTRLPROFILEINFO] = XPOSCTRLPROFILEINFO;
   giControlPosX[CTRLOHLCBAR    ] = XPOSCTRLOHLCBAR;
   giControlPosX[CTRLIB         ] = XPOSCTRLIB;
   giControlPosX[CTRLDIB        ] = XPOSCTRLDIB;
   giControlPosX[CTRLTVPOINFO   ] = XPOSCTRLTVPOINFO;   
   //<--On/Off Control
   
   //--> create gvar if not exist
   storeGVar(true);
   //<--
   
   //-->get gvar
   getGVar();
   //<--
}
/**
 * storeGVar
 */
void storeGVar(bool initval = false)
{
   int i, total = ArraySize(gsaGVName);
   string gvname;
   double val;
   bool exist; 
   for (i=0; i<total; i++)
   {
      gvname = getGVFullName(gsaGVName[i]);
      exist  = GlobalVariableCheck(gvname);
      
      if (initval && exist) continue;
            
      switch (i)
      {
         case GVMODELETTER:      val = ModeLetter;       break;
         case GVSHOWPROFILEINFO: val = ShowProfileInfo;  break;
         case GVSHOWCURRENTTVPO: val = ShowCurrentTVPO;  break;
         case GVSHOWOHLCBAR:     val = ShowOHLCBar;      break;
         case GVSHOWIB:          val = ShowIB;           break;
         case GVSHOWDIB:         val = ShowDIB;          break;
      }
      
      GlobalVariableSet(gvname, val);
   }

}
/**
 * getGVar
 */
void getGVar()
{
   int i, total = ArraySize(gsaGVName);
   string gvname;
   
   for (i=0; i<total; i++)
   {
      gvname = getGVFullName(gsaGVName[i]);
                  
      switch (i)
      {
         case GVMODELETTER:      ModeLetter      = GlobalVariableGet(gvname); break;
         case GVSHOWPROFILEINFO: ShowProfileInfo = GlobalVariableGet(gvname); break;
         case GVSHOWCURRENTTVPO: ShowCurrentTVPO = GlobalVariableGet(gvname); break;
         case GVSHOWOHLCBAR:     ShowOHLCBar     = GlobalVariableGet(gvname); break;
         case GVSHOWIB:          ShowIB          = GlobalVariableGet(gvname); break;
         case GVSHOWDIB:         ShowDIB         = GlobalVariableGet(gvname); break;
      }      
   }   
} 
 
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   delObjs();
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
      
   static bool isbusy;
        
   if (isbusy) { Print("start() is busy, come back later"); return(0); }   
   if (!isHistoryOK()) return(0);
   if (!isTimeForUpdate()) return(0);
         
   isbusy = true;              
   
   bool settingchanged = updateOnOffSetting();
   
   //-->MpGet Vars
   double     hh, ll;
   int        startbar, endbar;    
   double     mpdata  [][MPSIZE];
   int        mplines   [MPLNSIZE];
   double     mptotal   [MPTSIZE];
   int        mpletter[][MPLTSIZE];   
   double     dparam[4];
   int        iparam[2];      
   int        ratessize = iBars(NULL, giDataTf)
            , mpdatasize;
   //<--MpGet Vars
   
   double     poc, vah, val, open, close;    
   double     rhh //round hh to rowheight
            , rll //round ll to rowheight
            , rg = (giStep/1.0)/(MathPow(10,giDigits))
            , ibh, ibl, dibh, dibl;
   int        i
            , iprofile
            , ibstartbar
            , maxtpo
            , maxlook = 1
            , startprofile
            , laststartprofile = 0
            , space = 5;         
            
   //redraw all profile on newbar data or settingchanged
   //else: redraw only #0 profile
   if ( newBarDataTf() || settingchanged) 
   {
      delObjs(gsPref + "#");
      maxlook = LookBack;
   }
   else delObjs(gsPref + "#0");        
   
   
   //-->Main Loop
   for (iprofile=0; iprofile<maxlook; iprofile++)
   {
      //getStartAndEndBar(int ibarhtf, int &startbar, int &endbar, int htf, int ltf, int dsh=0)
      
      getStartAndEndBar(iprofile, startbar, endbar, giProfileTf, giDataTf, DayStartHour);   
      
        
      //skip ....     
      //when getStartAndEndBar  returning startbar/endbar < 0
      //when sundaybar on daily profile
      if (    startbar<0 
           || endbar  <0                  
           || (   TimeDayOfWeek(iTime(NULL, giDataTf, startbar)) == 0 
               && TimeDayOfWeek(iTime(NULL, giDataTf, endbar)) == 0 
               && giProfileTf == PERIOD_D1
               && DayStartHour == 0 ) 
         ) 
      {
         Print("skipping iprofile#", iprofile, " startbar ", startbar, " endbar ", endbar);
         continue;
      }
      
      //-->Prepare data for library fn call
      getHHLL
      (
           giDataTf        //int       tf
         , startbar        //int       sb
         , endbar          //int       eb
         , hh              //double&   hh
         , ll              //double&   ll
      );      
            
      rhh = MathCeil(hh/rg) * rg;
      rll = MathCeil(ll/rg) * rg;
      if (rhh < hh) rhh += rg;
      if (rll > ll) rll -= rg;
      
      dparam[MPDP_ONETICK]    = gdOneTick;
      dparam[MPDP_HH]         = rhh;
      dparam[MPDP_LL]         = rll;
      dparam[MPDP_VAPERCENT]  = VAPercent;

      iparam[MPIP_STARTBAR]   = startbar;
      iparam[MPIP_ENDBAR]     = endbar;
      //<--Prepare data for library fn call
      
      //-->call library
      MpGet
         (
   
              dparam       //double    dparam[4]
            , iparam       //int       iparam[2]
            , gdaRates     //double    arates[][6]
            , mpdata       //double&   mpdata[][MPSIZE]                                  //result: data
            , mplines      //int&      mplinesidx[MPLNSIZE]                              //result: lines index
            , mptotal      //double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
            , mpletter     //int&      mpletter[][MPLTSIZE]                              //result: letter  
         );
      //<--call library               
      
      //-->prepare profile position
      mpdatasize = ArraySize(mpdata)/MPSIZE;
      maxtpo = mpdata[ mplines[MPL_TPOPOC] ][MP_TPO];   
      
      startprofile      = laststartprofile + maxtpo + space;      
      laststartprofile  = startprofile;
      //<--prepare profile position
      
      //-->Draw OHLCBar, Value Area, POC Line
      if (ShowOHLCBar)
      {
         open  = iOpen(NULL, giDataTf, startbar);
         close = iClose(NULL, giDataTf, endbar);      
         drawBar( iprofile, startprofile+2, open, hh, ll, close );
      }
      
      createRect( "#"+iprofile+".va" 
         , mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE], Time[ startprofile + 1 ]
         , mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE], Time[ startprofile - (maxtpo+1) ]
         , VAColor );
                   
      createTl("#" + iprofile + ".poc"
         , Time[ startprofile + 1 ]  , mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE]
         , Time[ startprofile - (maxtpo+1) ], mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE]
         , POCColor, STYLE_SOLID, 2//, false
         );            
      //<--Draw OHLCBar, Value Area, POC Line                                 
      
      //-->Price Letter/Price Histogram
      if (ModeLetter)
      {           
         drawPriceLetter
         (
              iprofile           //int    iprofile
            , startprofile       //int    sbprofile
            , startbar           //int    sbdatatf
            , startbar - endbar  //int    totalbar
            , mpdatasize         //int    mpdatasize           
            , mpdata             //double mpdata[][]
            , mplines            //int    mplines[]
            , mpletter           //int    mpletter[][]
         ); 
      }
      else
      {
         drawPriceHistogram
         (
              iprofile              //int    iprofile
            , startprofile          //int    sbprofile
            , startbar - endbar     //int    totalbar
            , mpdatasize            //int    mpdatasize           
            , mpdata                //double mpdata[][]
         );                        
      }
      //<--Price Letter/Price Histogram
      
      //-->Initial Balance, DIB  
      ibstartbar = iBarShift(NULL, giIBTf, iTime(NULL, giDataTf, startbar)) ;
      getHHLL(giIBTf, ibstartbar, MathMax(ibstartbar-(giIBNumBars-1), 0), ibh, ibl);
      dibh = ibh+(ibh-ibl);
      dibl = ibl-(ibh-ibl);
            
      if (ShowIB)
      {                                             

      createTl("#" + iprofile + "2.0.ib"
         , Time[startprofile+1], ibh 
         , Time[startprofile+1], ibl
         , IBColor, STYLE_SOLID, 2, false
         );                                                   
      }
      
      if (ShowDIB)
      {
         createTl("#" + iprofile + "1.0.dib"
            , Time[startprofile+1], dibh
            , Time[startprofile+1], dibl
            , DIBColor, STYLE_SOLID, 2, false
            );     
      }
      //<--Initial Balance, DIB  

      //-->Profile Info  
      if (ShowProfileInfo) 
      {
         double infoposadj = ( (giStep/1.0) * gdPoint );
         string strinfo[14];
         strinfo[0]  = addStr(TimeToStr(iTime(NULL, giDataTf, startbar), TIME_DATE)                      , " ", 16, false); 
         strinfo[1]  = addStr("O     : " + DoubleToStr(open, giDigits)                                   , " ", 16, false); 
         strinfo[2]  = addStr("H     : " + DoubleToStr(hh, giDigits)                                     , " ", 16, false); 
         strinfo[3]  = addStr("L     : " + DoubleToStr(ll, giDigits)                                     , " ", 16, false); 
         strinfo[4]  = addStr("C     : " + DoubleToStr(close, giDigits)                                  , " ", 16, false);          
         strinfo[5]  = addStr("V     : " + DoubleToStr(mptotal[MPT_VOL], 0)                              , " ", 16, false);  
         strinfo[6]  = addStr("RANGE : " + DoubleToStr((hh-ll)/gdPoint, 0)                               , " ", 16, false); 
         strinfo[7]  = addStr("VAH   : " + DoubleToStr(mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE], giDigits), " ", 16, false); 
         strinfo[8]  = addStr("POC   : " + DoubleToStr(mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE], giDigits), " ", 16, false); 
         strinfo[9]  = addStr("VAL   : " + DoubleToStr(mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE], giDigits), " ", 16, false); 
         strinfo[10] = addStr("IBH   : " + DoubleToStr(ibh,  giDigits)                                   , " ", 16, false); 
         strinfo[11] = addStr("IBL   : " + DoubleToStr(ibl,  giDigits)                                   , " ", 16, false); 
         strinfo[12] = addStr("DIBH  : " + DoubleToStr(dibh, giDigits)                                   , " ", 16, false); 
         strinfo[13] = addStr("DIBL  : " + DoubleToStr(dibl, giDigits)                                   , " ", 16, false); 
         
         for (i=0; i<ArraySize(strinfo); i++)
         {
            createText( "#" + iprofile + ".info" + i   
               , Time[ (startprofile - (maxtpo)/2) ]
               , hh + (infoposadj *((ArraySize(strinfo)+1)-i))
               , strinfo[i]
               , FONTSIZE, FONTNAME, POCColor
               );                  
         }         
      }                 
      //<--ProfileInfo
      
      //-->TVPO info
      if ( iprofile==0 && ShowCurrentTVPO ) drawTVPOinfo(mpdatasize, mpdata);                       
      //<--TVPO info
   }
   //<--Main Loop
   
   
   //drawSettingInfo();
        
   if (isbusy) isbusy = false;   
      
   return(0);
}

/**
 *
 */
bool updateOnOffSetting()
{
   
   int     i;
   string  objname;
   color   clr;   
   bool    changed = false;
   
   for (i=0; i<ArraySize(gbOnOffControl); i++)
   {
      objname = gsPref + "ctrl" + i;      
      if (ObjectFind(objname) != 0)
      {
         switch (i)
         {
            case CTRLMODELETTER:  ModeLetter      = !ModeLetter;       changed = true; break;
            case CTRLPROFILEINFO: ShowProfileInfo = !ShowProfileInfo;  changed = true; break;
            case CTRLOHLCBAR:     ShowOHLCBar     = !ShowOHLCBar;      changed = true; break;
            case CTRLIB:          ShowIB          = !ShowIB;           changed = true; break;
            case CTRLDIB:         ShowDIB         = !ShowDIB;          changed = true; break;
            case CTRLTVPOINFO:    ShowCurrentTVPO = !ShowCurrentTVPO;  changed = true; break; 
         }    
      }      
   }
   
   
   
   storeCtrlSetting();   
   drawOnOffControl();
   
   if (changed) storeGVar();
   
   return(changed);
} 

/**
 *
 */
void storeCtrlSetting()
{
   gbOnOffControl[CTRLMODELETTER ] = ModeLetter;
   gbOnOffControl[CTRLPROFILEINFO] = ShowProfileInfo;
   gbOnOffControl[CTRLOHLCBAR    ] = ShowOHLCBar;
   gbOnOffControl[CTRLIB         ] = ShowIB;   
   gbOnOffControl[CTRLDIB        ] = ShowDIB;
   gbOnOffControl[CTRLTVPOINFO   ] = ShowCurrentTVPO;
}
/**
 *
 */
void drawSettingInfo()
{
   
   string ainfo[7];
   int    i, cnt, x=STARTX, y=STARTY;  
   color  clr;
   
   ainfo[0] = addStr("ProfileTf     : " + ProfileTimeframe        , " ", 25, false);
   ainfo[1] = addStr("ProfileDataTf : " + getTfName(giDataTf)     , " ", 25, false);
   ainfo[2] = addStr("IBTf          : " + getTfName(giIBTf)       , " ", 25, false);
   ainfo[3] = addStr("IBNumBars     : " + giIBNumBars + " Bar(s)" , " ", 25, false);
   ainfo[4] = addStr("RowHeight     : " + giRowHeight + " Pip(s)" , " ", 25, false);
   ainfo[5] = addStr("DayStartHour  : " + DayStartHour            , " ", 25, false);
   ainfo[6] = addStr("On/Off Setting: Del(NUM)"                   , " ", 25, false);
   
   if (giProfileTf == PERIOD_D1) cnt=6;
   else cnt=5;
    
   for (i = 0; i<cnt; i++)
   {
      lblCreate("info"+i, x, y, ainfo[i], InfoCorner, POCColor, FONTSIZE, FONTNAME);  
      lblCreate("0.0.0.infobg"+i, 0, y-2, addStr("", "g",12,false), InfoCorner, VAColor, FONTSIZE+2, "Webdings");    
      y+=12;
   }
           

   if (InfoCorner == 0 || InfoCorner == 2) x = 105;   
   lblCreate("info"+i, STARTX, CTRLSTARTY+15, ainfo[6], InfoCorner, POCColor, FONTSIZE, FONTNAME); 
   lblCreate("0.0.0.infobg"+i, 0, CTRLSTARTY+12, addStr("", "g",12,false), InfoCorner, VAColor, FONTSIZE+2, "Webdings");   
   
   drawOnOffControl();
}

/**
 *drawOnOffControl
 */
void drawOnOffControl()
{
   int i;
   color clr;
   
   for (i=0; i<ArraySize(gbOnOffControl); i++)
   {
      if (gbOnOffControl[i]) clr = CTRLONCOLOR;
      else clr = CTRLOFFCOLOR;
      
      lblCreate("ctrl"+i, giControlPosX[i], CTRLSTARTY, CharToStr(140+i), InfoCorner, clr, 11, "Wingdings");

   }   
   
} 
/**
 *drawBar
 */
void drawBar( int barnum, int pos, double o, double h, double l, double c )
{
   color barclr;
   if (c>o)barclr=BarBullColor; else
   if (c<o)barclr=BarBearColor; else
           barclr=BarNetralColor;   

   createTl("#" + barnum + ".bar.spread"
      , Time[pos], h
      , Time[pos], l
      , barclr, STYLE_SOLID, 2, false
      );            
   
   createTl("#" + barnum + ".bar.o"
      , Time[pos+1], o
      , Time[pos], o
      , barclr, STYLE_SOLID, 2, false
      ); 
      
   createTl("#" + barnum + ".bar.c"
      , Time[pos-1], c
      , Time[pos], c
      , barclr, STYLE_SOLID, 2, false
      );       
}
/**
 *getStartAndEndBar
 */
void getStartAndEndBar(int ibarhtf, int &startbar, int &endbar, int htf, int ltf, int dsh=0)
{      
   
   int i, j, q, year, month, quarter;
   datetime dt.htf;     
   datetime dt.htf.end; 
    
   switch (htf)
   {
      case PERIOD_D1:

         startbar = 0; endbar = 0;     
                      
         int oneday  = (PERIOD_D1*60) - 1; // -1 is for .... like 23:59:xxxx
         int idsh    = dsh * PERIOD_H1 * 60;
   
         datetime dt.starthour, dt.endhour;
         int  sb = 0       //startbar
            , eb = 0;      //endbar            
         
         if ( TimeHour(iTime(NULL, ltf, 0)) < dsh) ibarhtf++;
   
         dt.htf       = iTime( NULL, htf, ibarhtf ); 
         dt.starthour = dt.htf + idsh; 
         //if (dt.starthour > Time[0]) dt.starthour -= (oneday+1); 
         dt.endhour   = dt.starthour + oneday;
         
         if ( TimeDayOfWeek(dt.endhour) == 6 ) 
         {
            dt.endhour += (2*oneday);         
         }
                     
         sb  = iBarShift ( NULL, ltf, dt.starthour ); 
         eb  = iBarShift ( NULL, ltf, dt.endhour ); 
   
         //missing hour
         if ( iTime(NULL, ltf, sb) < dt.starthour )
         {
            //use the next bar for startbar
            sb--;     
          
            dt.endhour = StrToTime( TimeToStr(iTime( NULL, ltf, sb), TIME_DATE) ) + idsh - 1;
            
            if ( dt.endhour <= iTime( NULL, ltf, sb) ) dt.endhour += oneday;
      
            eb = iBarShift( NULL, ltf, dt.endhour );         
         }
                  
         startbar = sb;
         endbar   = eb;         
                                                  
      break;
      
      case PERIOD_Q1:
         year   = TimeYear(Time[0]);
         month  = TimeMonth(Time[0]);
         
         if (month>=1 && month<=3)  quarter = 1; else   //q1
         if (month>=4 && month<=6)  quarter = 2; else   //q2         
         if (month>=7 && month<=9)  quarter = 3; else   //q3
                                    quarter = 4;        //q4
         
         for (i=0; i<=ibarhtf; i++)
         {
            if (quarter == 1)
            {
               dt.htf      = StrToTime(year + ".01.01 00:00");
               dt.htf.end  = StrToTime(year + ".04.01 00:00") - 1; // -1 = - one second           
            } 
            else 
            if (quarter == 2)
            {
               dt.htf      = StrToTime(year + ".04.01 00:00");
               dt.htf.end  = StrToTime(year + ".07.01 00:00") - 1;                
            }
            else 
            if (quarter == 3)
            {
               dt.htf      = StrToTime(year + ".07.01 00:00");
               dt.htf.end  = StrToTime(year + ".10.01 00:00") - 1;             
            }
            else 
            if (quarter == 4)
            {
               dt.htf      = StrToTime(year + ".10.01 00:00");
               dt.htf.end  = StrToTime((year+1) + ".01.01 00:00") - 1;             
            }
            
            
            if (quarter==1) 
            {
               quarter = 4;
               year--;  
            }          
            else quarter--;
            //{

            //}
         }                 
         
         startbar  = iBarShift ( NULL, ltf, dt.htf);
         endbar    = iBarShift ( NULL, ltf, dt.htf.end);  
                  
         if ( iTime(NULL, ltf, startbar) < dt.htf ) startbar--; 
                  
      break;  
           
      case PERIOD_Y1:
         year           = TimeYear(Time[0]) - ibarhtf;
         dt.htf      = StrToTime(year + ".01.01 00:00");
         dt.htf.end  = StrToTime(year + ".12.31 23:59");
         
         startbar  = iBarShift ( NULL, ltf, dt.htf);
         endbar    = iBarShift ( NULL, ltf, dt.htf.end);  
                  
         if ( iTime(NULL, ltf, startbar) < dt.htf ) startbar--; 
                  
      break;        
      
      default:
         dt.htf      = iTime( NULL, htf, ibarhtf );
         dt.htf.end  = iTime( NULL, htf, ibarhtf - 1 );
         
         startbar  = iBarShift ( NULL, ltf, dt.htf);
         endbar    = iBarShift ( NULL, ltf, dt.htf.end - (ltf * 60) );
         //current week, month         
         if (dt.htf.end < dt.htf) endbar = 0;         
         // fix iBarShift on month\week start
         if ( iTime(NULL, ltf, startbar) < dt.htf ) startbar--;    
                           
      break;
   }         
}

/**
 *
 */
void drawPriceLetter
(
     int    iprofile
   , int    sbprofile
   , int    sbdatatf
   , int    totalbar
   , int    mpdatasize           
   , double mpdata[][]
   , int    mplines[]
   , int    mpletter[][]
)
{          
   
   int      maxtpoidx  = mplines[MPL_TPOPOC];
   double   maxtpo     = mpdata[maxtpoidx][MP_TPO];
           
   double   price1, price2, dstep;
   double     numtpo, numvol;
   int        step, step2, stepl, i, j, pos
            , letterid;
   string     letter;
   color    clr;
   datetime dtprofilestart = iTime(NULL, giDataTf, sbdatatf);
   datetime dtTO, dtLO, dtNO;
   datetime bartime;
   
   if (giProfileTf == PERIOD_D1)
   {
      dtTO  = StrToTime( TimeToStr( dtprofilestart, TIME_DATE ) ) + (TokyoOpen*PERIOD_H1*60);
      
      dtLO  = StrToTime( TimeToStr( dtprofilestart, TIME_DATE ) ) + (LondonOpen*PERIOD_H1*60); 
      if (dtLO<dtTO) dtLO += PERIOD_D1*60;
      
      dtNO  = StrToTime( TimeToStr( dtprofilestart, TIME_DATE ) ) + (NewyorkOpen*PERIOD_H1*60);   
      if (dtNO<dtLO) dtNO += PERIOD_D1*60; 
   }
         
   for (step = 0; step<mpdatasize; step += giStep)
   {
      price1   = mpdata[ step ][MP_PRICE];
      step2    = MathMin(step+giStep, mpdatasize-1);
      price2   = mpdata[ step2 ][MP_PRICE];  
      
      numtpo   = mpdata[step][MP_TPO];  
      stepl    = step;          
      for (i=step; i < step2; i++)
      {         
        if (  mpdata[i][MP_TPO] > numtpo)
        {
            numtpo = mpdata[i][MP_TPO];
            stepl = i;
        } 
      }   

      pos = sbprofile;            
      for (j=0; j<MPLTSIZE; j++)
      {
         if ( mpletter[stepl][j] == -1) break;
         
         letterid =  mpletter[stepl][j] ;
         bartime  =  iTime(NULL, giDataTf, sbdatatf-letterid);
         
         //if ( letterid == totalbar ) clr = CurrentLetterColor;
         //else
         if (giProfileTf == PERIOD_D1 /*&& letterid != totalbar*/)
         {            
            int sbsess; //session startbar
            if (bartime >= dtNO)
            { clr = UsColor; sbsess = iBarShift(NULL, giDataTf, dtNO); }
            else
            if (bartime >= dtLO) 
            { clr = EuColor; sbsess = iBarShift(NULL, giDataTf, dtLO); }
            else
            if (bartime >= dtTO) 
            { clr = AsColor; sbsess = iBarShift(NULL, giDataTf, dtTO); }
            
            letterid = letterid - (sbdatatf-sbsess);
         }                  
         else
         if (giProfileTf == PERIOD_W1 /*&& letterid != totalbar*/)
         { 
            int tdw = TimeDayOfWeek(bartime);
            //if (tdw==0) tdw++;
            int sbday = iBarShift(NULL, giDataTf, iTime(NULL, PERIOD_D1, iBarShift(NULL, PERIOD_D1, bartime))); 
            if ( iTime(NULL, giDataTf, sbday) < bartime ) sbday--;
            
            clr = gcLtColor[tdw]; 
            letterid = letterid - (sbdatatf-sbday);
            
         }
         else
         if (giProfileTf == PERIOD_MN1 /*&& letterid != totalbar*/)
         {
            int weekstart = iBarShift(NULL, PERIOD_W1, iTime(NULL, giDataTf, sbdatatf) );
            int sbweek = iBarShift(NULL, giDataTf, iTime(NULL, PERIOD_W1, iBarShift(NULL, PERIOD_W1, bartime))); 
            if ( iTime(NULL, giDataTf, sbweek) < bartime ) sbweek--;

            clr = gcLtColor[weekstart - iBarShift(NULL, PERIOD_W1, bartime)];  
            letterid = letterid - (sbdatatf-sbweek); 
         }
         else
         if (giProfileTf >= PERIOD_Q1 /*&& letterid != totalbar*/)
         {
            int clridx = TimeMonth(bartime)-1;   
            int sbmonth = iBarShift(NULL, giDataTf, iTime(NULL, PERIOD_MN1, iBarShift(NULL, PERIOD_MN1, bartime))); 
            if ( iTime(NULL, giDataTf, sbmonth) < iTime(NULL, PERIOD_MN1, iBarShift(NULL, PERIOD_MN1, bartime)) ) sbmonth--;                                 
            
            clr = gcLtColor[ clridx ];   
            letterid = letterid - (sbdatatf-sbmonth); 
         }
         else clr = LetterColor;
         
                  
         if (letterid>50) letterid = MathMod(letterid,50);
         
         letter = gsaLetter[ letterid ];
                  
         createText( "#" + iprofile + ".letter." + step + "-" + j
            , Time[pos]
            , price1
            , letter
            , FONTSIZE2, FONTNAME2, clr
            );          
         
         pos--;
      }      
   }
   
      
}
/**
 *
 */
void drawPriceHistogram
(
     int    iprofile
   , int    sbprofile
   , int    totalbar
   , int    mpdatasize           
   , double mpdata[][]
)
{
   
   double   price1, price2, dstep;
   int      inumtpo; 
   double   numtpo, numvol;
   int      step, step2, i;
   datetime t1             = Time[sbprofile], t2;
   double   lprice         = mpdata[mpdatasize-1][MP_PRICE]; 
   
   //color vars... 
   color clr = HistogramColor;   
   color clr2; //darker color
   
   int  iclr = -64, ired, igreen, iblue;

   intToRGB(clr, ired, igreen, iblue);
   getNextGradColor( iclr, ired, igreen, iblue, true ); 
   clr2 = RGB(ired, igreen, iblue); 
                     
   int stepplus = giRowHeight; //MathMax(MathCeil(((mpdatasize/1.0)/200)), 5); 
   //if (mpdatasize<50) stepplus = 2; 

   for (step=0; step < mpdatasize; step += stepplus)      
   {
      price1   = mpdata[ step ][MP_PRICE];
      step2    = MathMin(step+stepplus, mpdatasize-1);
      price2   = mpdata[ step2 ][MP_PRICE];     
         
      numtpo   = 0;      
      for (i=step; i < step2; i++)
         numtpo = MathMax( numtpo, mpdata[i][MP_TPO] ); 
                     
     
      inumtpo = MathRound(numtpo);
                          
      t2 = Time[sbprofile - inumtpo] ;
      
      createRect( "#" + iprofile + ".histoprice.border." + step
         , price1,                  t1
         , MathMax(price2, lprice), t2
         , clr, false );      
       
      createRect( "#" + iprofile + ".histoprice.fill" + step
         , price1,                  t1
         , MathMax(price2, lprice), t2
         , clr2 );                                   
                                       
   }          

} 
 
/**
 *
 */
void drawTVPOinfo
(
     int    mpdatasize           
   , double mpdata[][]
   //, int    mplines[]
   //, int    mpletter[][]
)
{
   int        step, step2, i;
   //double     stepmaxtpo, stepmaxvol;
   double     steptpo, stepvol;
   createText( "#0.info.price"
      , Time[0] + (10*Period()*60)
      , mpdata[0][MP_PRICE] + (giStep*gdPoint)
      , addStr("Price", " ", 7)
      , FONTSIZE, FONTNAME, LetterColor
      );
      
   createText( "#0.info.tpo"
      , Time[0] + (15*Period()*60)
      , mpdata[0][MP_PRICE] + (giStep*gdPoint)
      , addStr("SumTPO", " ", 7)
      , FONTSIZE, FONTNAME, LetterColor
      );         
         
   createText( "#0.info.vol"
      , Time[0] + (20*Period()*60)
      , mpdata[0][MP_PRICE] + (giStep*gdPoint)
      , addStr("SumVPO", " ", 10)
      , FONTSIZE, FONTNAME, LetterColor
      );    
   
   for (step = 0; step<mpdatasize; step += giStep)
   {
      steptpo = 0.0;
      stepvol = 0.0; 
      step2 = MathMin(step+giStep, mpdatasize-1);     
      
      for (i=step; i<step2; i++)
      {         
         //stepmaxtpo = MathMax( stepmaxtpo, mpdata[i][MP_TPO] );
         //stepmaxvol = MathMax( stepmaxvol, mpdata[i][MP_VOL] ); 
         steptpo += mpdata[i][MP_TPO];
         stepvol += mpdata[i][MP_VOL];         
      }           
      
      createText( "#0.info.price.bg." + step
         , Time[0] + (10*Period()*60)
         , mpdata[step][MP_PRICE]
         , addStr("", "_", 7)
         , FONTSIZE, FONTNAME, VAColor
         );
            
      createText( "#0.info.price." + step
         , Time[0] + (10*Period()*60)
         , mpdata[step][MP_PRICE]
         , addStr(DoubleToStr(mpdata[step][MP_PRICE], giDigits), " ", 7)
         , FONTSIZE, FONTNAME, POCColor
         );
      createText( "#0.info.tpo.bg." + step
         , Time[0] + (15*Period()*60)
         , mpdata[step][MP_PRICE]
         , addStr("", "_", 7)
         , FONTSIZE, FONTNAME, VAColor
         );         
      createText( "#0.info.tpo." + step
         , Time[0] + (15*Period()*60)
         , mpdata[step][MP_PRICE]
         , addStr(DoubleToStr(steptpo, 0), " ", 7)
         , FONTSIZE, FONTNAME, POCColor
         );         
      createText( "#0.info.vol.bg." + step
         , Time[0] + (20*Period()*60)
         , mpdata[step][MP_PRICE]
         , addStr("", "_", 10)
         , FONTSIZE, FONTNAME, VAColor
         );            
      createText( "#0.info.vol." + step
         , Time[0] + (20*Period()*60)
         , mpdata[step][MP_PRICE]
         , addStr(DoubleToStr(stepvol, 0), " ", 10)
         , FONTSIZE, FONTNAME, POCColor
         );   
   }
}

/**
 *getHHLL                                                          
*/
void getHHLL
(
     int       tf
   , int       sb
   , int       eb
   , double&   hh
   , double&   ll
)
{
   hh = iHigh ( NULL, tf, iHighest(NULL, tf, MODE_HIGH, (sb-eb)+1, eb) );
   ll = iLow  ( NULL, tf, iLowest (NULL, tf, MODE_LOW,  (sb-eb)+1, eb) );
} 
//+------------------------------------------------------------------+
//| isTimeForUpdate                                                   |
//+------------------------------------------------------------------+ 
bool isTimeForUpdate()
{
   static datetime lasttime ;
   int diff = TimeLocal() - lasttime ;

   if (diff >= UpdateInterval )
   {
      lasttime = TimeLocal();
      return (true);
   }
   
   return (false);
   
} 

bool newBarDataTf()
{
   static datetime LastBar;
   datetime CurrBar = iTime(NULL, giDataTf, 0);

   if(LastBar != CurrBar)
   {
      LastBar = CurrBar;
      return (true);
   }
   return(false);  
}
//+------------------------------------------------------------------+
//| addStr                                                           |
//+------------------------------------------------------------------+ 
string addStr(string str, string char, int maxlength, bool atbeginning = true)
{
   int l = maxlength - StringLen(str);
   for (int i=0; i<l; i++)
   {
      if (atbeginning) str = char + str;
      else str = str + char;
   }
      
   return(str);
}
/**
 *
 */
bool isHistoryOK()
{    

   if (giProfileTf != PERIOD_Y1 && giProfileTf != PERIOD_Q1) 
   {
      if (  !checkHist(giProfileTf) 
         || !checkHist(giDataTf) 
         || !checkHist(Period())
      )  return(false); 
   }
   else
   {
      if (  !checkHist(giDataTf) 
         || !checkHist(Period())
      )  return(false);          
   }

   //Comment("");
   return(true);
}
/**
 *
 */
bool checkHist(int tf, int retries = 0/*second*/)
{
  
   int i, bars, err;
   
   bars = iBars(Symbol(), tf);      
   err  = GetLastError();   
      
   if (err==0) return(true);
   //Comment("Waiting for timeframe ", tf, " minutes to be ready");   
   
   return(false);

}
/**
 *getTfByName
 */
int getTfByName(string tfname)
{
   int p;
   
   if      (tfname == "Y1")  p = PERIOD_Y1;
   else if (tfname == "Q1")  p = PERIOD_Q1;       
   else if (tfname == "MN1") p = PERIOD_MN1;
   else if (tfname == "W1" ) p = PERIOD_W1;
   else if (tfname == "D1" ) p = PERIOD_D1;
   else if (tfname == "H4" ) p = PERIOD_H4;
   else if (tfname == "H1" ) p = PERIOD_H1;
   else if (tfname == "M30") p = PERIOD_M30;
   else if (tfname == "M15") p = PERIOD_M15;
   else if (tfname == "M5" ) p = PERIOD_M5;
   else if (tfname == "M1" ) p = PERIOD_M1;
   else p = Period();  
  
   return(p);  

} 
/**
 *getTfName
 */
string getTfName(int tf)
{
   string tfname;
   
   if      (tf == PERIOD_Y1)  tfname = "Y1";
   else if (tf == PERIOD_Q1)  tfname = "Q1";       
   else if (tf == PERIOD_MN1) tfname = "MN1";
   else if (tf == PERIOD_W1)  tfname = "W1";
   else if (tf == PERIOD_D1)  tfname = "D1";
   else if (tf == PERIOD_H4)  tfname = "H4";
   else if (tf == PERIOD_H1)  tfname = "H1";
   else if (tf == PERIOD_M30) tfname = "M30";
   else if (tf == PERIOD_M15) tfname = "M15";
   else if (tf == PERIOD_M5)  tfname = "M5";
   else if (tf == PERIOD_M1)  tfname = "M1";
   else tfname = "??";  
  
   return(tfname);  

}
/**
 *
 */
string getGVFullName(string name)
{
   return(INDNAME + "." + INDVER + "." + Symbol() + "." + IndicatorId + "." + ProfileTimeframe + "." + name);
}
/*
void setGV(string gvfullname, double value)
{
   GlobalVariableSet(gvfullname, value);
}

double getGV(string gvfullname){
   return(GlobalVariableGet(gvfullname));
}
*/

//+------------------------------------------------------------------+

/*
mzvega: IB
http://www.forexfactory.com/showpost.php?p=4524586&postcount=1627

Daily IB       = first 60m
Weekly IB      = first 2 days
Monthly IB     = first week
Quarterly IB   = first month
Yearly IB      = first 3 months
*/